/**
 * @file
 * Helper for entity reference proc field.
 */
(function($, Drupal, once) {
  Drupal.behaviors.ProcBehavior = {
    attach(context, settings) {
      once('proc-decrypt', 'html', context).forEach(function(element) {
        const procFieldElements = document.querySelectorAll('[proc="true"]');
        const procFields = [];

        procFieldElements.forEach((fieldElement, fieldElementIndex) => {
          procFields.push(
            fieldElement.attributes.name.value.substring(
              0,
              fieldElement.attributes.name.value.indexOf('['),
            ),
          );
        });

        if (drupalSettings.proc && drupalSettings.proc.submit_element_id) {
          const submitId = drupalSettings.proc.submit_element_id;

          const submitElement = document.getElementById(submitId);

          procFields.map((fieldName, fieldIndex) => {
            const field = document.querySelector(`[name^="${fieldName}"]`);
            field.oninput = () => {
              if (submitElement.disabled === false && field.value != '') {
                // Disable submit when something is typed in for encryption:
                submitElement.disabled = true;
              }
              if (submitElement.disabled === true && field.value === '') {
                submitElement.disabled = false;
              }
            };

            const encryptCheckbox = document.querySelector(
              `[id="encrypt-checkbox-${fieldName}"]`,
            );
            encryptCheckbox.oninput = () => {
              if (
                encryptCheckbox.value === '1' &&
                submitElement.disabled === true
              ) {
                // If for all other fields there is no plain text:
                let index = 0;
                procFields.map((fieldName, fieldIndex) => {
                  if (
                    !document
                      .querySelector(`[name^="${fieldName}"]`)
                      .value.startsWith('******* (')
                  ) {
                    index++;
                  }
                });
                if (index === 1) {
                  submitElement.disabled = false;
                }
              }
              if (
                encryptCheckbox.value === '0' &&
                submitElement.disabled === false
              ) {
                submitElement.disabled = true;
              }
            };
          });
        }
      });
    },
  };
})(jQuery, Drupal, once);
